<?php
function getField($arr, $f) {
       if (isset($arr[$f]) && $arr[$f]) return intval($arr[$f]);
       else return "";
    }

$MAX_TIMES = 10;
$DEFAULT_GRANULARITY = 100;

header ('Content-type: image/png');
/*$im = @imagecreatetruecolor(300, 100)
      or die('Cannot Initialize new GD image stream');
$text_color = imagecolorallocate($im, 233, 14, 91);
//imageantialias($im, true);
imagesetthickness($im, 10);
imagestring($im, 18, 5, 5,  'A Simple Text String', $text_color);
imageline($im, 10, 10, 200, 300, $text_color);
imagepng($im);
imagedestroy($im);*/

$R = getField($_REQUEST, "rr");
$r = getField($_REQUEST, "r");
$d = getField($_REQUEST, "d");
$theta = getField($_REQUEST, "t");
$granularity = getField($_REQUEST, "g");

$randR = rand(50,75);
$temp = rand(1,4);
for($i = 0; $i < 100; $i++)
{
   $randr = $temp*$randR/rand($temp+1,100);
   if($randr == floor($randr)) break;
   else $randr = 1;
}
$randd = rand(1,75);

$R = $R ? $R : $randR;
$r = $r ? $r : $randr;
$d = $d ? $d : $randd;
$theta = $theta ? $theta : 0;
$granularity = $granularity ? $granularity : $DEFAULT_GRANULARITY;

$numTimes = $MAX_TIMES;
for($i = 1; $i <= $MAX_TIMES; $i++)
{
   if((($i*$R) % $r) == 0)
   {
      $numTimes = $i;
      break;
   }
}

$width = 300; //($R-$r+$d)*2+20;
$height = $width;
$numPoints = 20; 

// -draw \"text 10,%d 'www.jrmcclurg.com'\" 
$command = sprintf("convert -size %dx%d xc:'white' -fill '#00000033' -fill 'lightblue' -stroke '#ff00aa' -strokewidth 1 ",$width,$height,$height-10,$numTimes,$R,$r,$d);
$bezier = "-draw \"polyline";
$points = "-stroke red -strokewidth 1";

for($i = 0; $i <= $numTimes*$granularity; $i++)
{
   $centerX = $width/2;
   $centerY = $height/2;

   $wheelX = $centerX+($R-$r)*cos($theta);
   $wheelY = $centerY-($R-$r)*sin($theta);

   $drawX = $wheelX+($d)*cos($theta*(1-$R/$r));
   $drawY = $wheelY-($d)*sin($theta*(1-$R/$r));

   $x = $drawX;
   $y = $drawY;

   $bezier .= sprintf(" %d,%d",$x,$y);
   $points .= sprintf(" -draw \"circle %d,%d,%d,%d\"",$x,$y,$x+2,$y);

   $theta += (2*pi()/$granularity);
}

$bezier .= "\"";

$command .= $bezier . " " . " -strip -depth 8 png:-";

//echo($command);
passthru($command);
?>
